#include <windows.h>
#include <math.h>
#include <vector>

using namespace std;


#include "aeffeditor.h"



#define GUI_WINDOW_WDT		595
#define GUI_WINDOW_HGT		215

#define GUI_COLOR_ERROR		RGB(255,255,128)

#define IDC_CHANNEL			10000



class GUI:public AEffEditor
{
	PETCB2 *pcspe;

private:

	char ClassName[32];

	HWND hWndForm;
	HWND hWndLabelC;
	HWND hWndLabelV;
	HWND hWndLabelA;
	HWND hWndLabelP;
	HWND hWndLabelW;
	HWND hWndLabelR;
	HWND hWndEditV;
	HWND hWndEditA;
	HWND hWndEditP;
	HWND hWndEditW;
	HWND hWndChannel[16];
	HWND hWndRangeStandard;
	HWND hWndRangeExpanded;
	HWND hWndLogFile;
	HWND hWndLogFileAuto;
	HWND hWndMultiMode;

	ERect rect;

	const char* GetClassName(void);

	static LRESULT WINAPI WndProc(HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam);

	bool NeedUpdate;
	bool NeedUpdateEdits;

public:

	GUI(AudioEffect* effect);

	~GUI();

	virtual bool open(void* ptr);

	virtual void close();

	virtual void idle();

	virtual bool getRect(ERect **ppRect);

	void SetUpdate(bool program);
};
